# postgresql_owner – Change an owner of PostgreSQL database object

New in version 2.8.

- Synopsis

- Requirements

- Parameters

- Notes

- See Also

- Examples

- Return Values

- Status

## Synopsis

- Change an owner of PostgreSQL database object.

- Also allows to reassign the ownership of database objects owned by a database role to another role.

## Requirements

The below requirements are needed on the host that executes this module.

- psycopg2

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
ca_cert string |  | Specifies the name of a file containing SSL certificate authority (CA) certificate(s). If the file exists, the server's certificate will be verified to be signed by one of these authorities. aliases: ssl_rootcert
db string |  | Name of database to connect to. aliases: login_db

fail_on_role
boolean

Choices:
- no
- yes ←

If `yes`, fail when reassign_owned_by role does not exist. Otherwise just warn and continue.
Mutually exclusive with obj_name and obj_type.

login_host string |  | Host running the database.
login_password string |  | The password used to authenticate with.
login_unix_socket string |  | Path to a Unix domain socket for local connections.
login_user string | Default: "postgres" | The username used to authenticate with.
new_owner string / required |  | Role (user/group) to set as an obj_name owner.
obj_name string |  | Name of a database object to change ownership. Mutually exclusive with reassign_owned_by.

obj_type
string / required

Choices:
- database
- function
- matview
- sequence
- schema
- table
- tablespace
- view

Type of a database object.
Mutually exclusive with reassign_owned_by.
aliases: type

port integer | Default: 5432 | Database port to connect to. aliases: login_port

reassign_owned_by
list / elements=string

The list of role names. The ownership of all the objects within the current database, and of all shared objects (databases, tablespaces), owned by this role(s) will be reassigned to owner.
Pay attention - it reassigns all objects owned by this role(s) in the db!
If role(s) exists, always returns changed True.
Cannot reassign ownership of objects that are required by the database system.
Mutually exclusive with `obj_type`.

session_role string |  | Switch to session_role after connecting. The specified session_role must be a role that the current login_user is a member of. Permissions checking for SQL commands is carried out as though the session_role were the one that had logged in originally.

ssl_mode
string

Choices:
- allow
- disable
- prefer ←
- require
- verify-ca
- verify-full

Determines whether or with what priority a secure SSL TCP/IP connection will be negotiated with the server.
See https://www.postgresql.org/docs/current/static/libpq-ssl.html for more information on the modes.
Default of `prefer` matches libpq default.

## Notes

Note

- The default authentication assumes that you are either logging in as or sudo’ing to the `postgres` account on the host.

- To avoid “Peer authentication failed for user postgres” error, use postgres user as a become_user.

- This module uses psycopg2, a Python PostgreSQL database adapter. You must ensure that psycopg2 is installed on the host before using this module.

- If the remote host is the PostgreSQL server (which is the default case), then PostgreSQL must also be installed on the remote host.

- For Ubuntu-based systems, install the postgresql, libpq-dev, and python-psycopg2 packages on the remote host before using this module.

- The ca_cert parameter requires at least Postgres version 8.4 and psycopg2 version 2.4.3.

## See Also

See also

postgresql_user – Add or remove a user (role) from a PostgreSQL server instance

  The official documentation on the postgresql_user module.

postgresql_privs – Grant or revoke privileges on PostgreSQL database objects

  The official documentation on the postgresql_privs module.

postgresql_membership – Add or remove PostgreSQL roles from groups

  The official documentation on the postgresql_membership module.

PostgreSQL REASSIGN OWNED command reference

  Complete reference of the PostgreSQL REASSIGN OWNED command documentation.

## Examples

    # Set owner as alice for function myfunc in database bar by ansible ad-hoc command:
    # ansible -m postgresql_owner -a "db=bar new_owner=alice obj_name=myfunc obj_type=function"

    - name: The same as above by playbook
      postgresql_owner:
        db: bar
        new_owner: alice
        obj_name: myfunc
        obj_type: function

    - name: Set owner as bob for table acme in database bar
      postgresql_owner:
        db: bar
        new_owner: bob
        obj_name: acme
        obj_type: table

    - name: Set owner as alice for view test_view in database bar
      postgresql_owner:
        db: bar
        new_owner: alice
        obj_name: test_view
        obj_type: view

    - name: Set owner as bob for tablespace ssd in database foo
      postgresql_owner:
        db: foo
        new_owner: bob
        obj_name: ssd
        obj_type: tablespace

    - name: Reassign all object in database bar owned by bob to alice
      postgresql_owner:
        db: bar
        new_owner: alice
        reassign_owned_by: bob

    - name: Reassign all object in database bar owned by bob and bill to alice
      postgresql_owner:
        db: bar
        new_owner: alice
        reassign_owned_by:
        - bob
        - bill

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
queries string | always | List of executed queries. Sample: ['REASSIGN OWNED BY "bob" TO "alice"']

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Andrew Klychkov (@Andersson007)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.